/*
 * mcubecgiout.cpp v 1.01
 * 4x4x4 Rubik's Cube Solver CGI/HTML interface (c) 2005 by Eric Dietz
 * notes: readme.txt  email: root@wrongway.org
 */

// includes
#include <stdlib.h>
#include <stdio.h>
#include <string>
// namespace
using namespace std;

// local includes
#include "mcube.h"

// shared variables
const char *version = "1.01";
mcube thecube;
string thesolution = "";
const int N = mcube::N;
string col[7];
string html = "";
string exec = "";
string inpt = "";
string parm = "";
string parm2 = "";
string parmcol = "";
int disp_graphics;
int disp_diagrams;

// render cube model in html form
void renderHTML(mcube c)
{
  printf("<table border=0 cellpadding=0 cellspacing=1><tr><td></td><td>\n");
  printf("<table border=1 width=42 height=42 bordercolor=#000000 cellpadding=0 cellspacing=0>\n");
  for (int i = 1; i <= N; i++) {
    printf("<tr>");
    for (int j = 1; j <= N; j++) {
      printf("<td bgcolor=#%s><table><tr><td></td></tr></table></td>", col[c.cube[j][N+1][N+1-i]].c_str());
    }
    printf("</tr>\n");
  }
  printf("</table></td><td colspan=2></td></tr><tr><td>\n");
  printf("<table border=1 width=42 height=42 bordercolor=#000000 cellpadding=0 cellspacing=0>\n");
  for (int i = 1; i <= N; i++) {
    printf("<tr>");
    for (int j = 1; j <= N; j++) {
      printf("<td bgcolor=#%s><table><tr><td></td></tr></table></td>", col[c.cube[0][N+1-i][N+1-j]].c_str());
    }
    printf("</tr>\n");
  }
  printf("</table></td><td>\n");
  printf("<table border=1 width=42 height=42 bordercolor=#000000 cellpadding=0 cellspacing=0>\n");
  for (int i = 1; i <= N; i++) {
    printf("<tr>");
    for (int j = 1; j <= N; j++) {
      printf("<td bgcolor=#%s><table><tr><td></td></tr></table></td>", col[c.cube[j][N+1-i][0]].c_str());
    }
    printf("</tr>\n");
  }
  printf("</table></td><td>\n");
  printf("<table border=1 width=42 height=42 bordercolor=#000000 cellpadding=0 cellspacing=0>\n");
  for (int i = 1; i <= N; i++) {
    printf("<tr>");
    for (int j = 1; j <= N; j++) {
      printf("<td bgcolor=#%s><table><tr><td></td></tr></table></td>", col[c.cube[N+1][N+1-i][j]].c_str());
    }
    printf("</tr>\n");
  }
  printf("</table></td><td>\n");
  printf("<table border=1 width=42 height=42 bordercolor=#000000 cellpadding=0 cellspacing=0>\n");
  for (int i = 1; i <= N; i++) {
    printf("<tr>");
    for (int j = 1; j <= N; j++) {
      printf("<td bgcolor=#%s><table><tr><td></td></tr></table></td>", col[c.cube[N+1-j][N+1-i][N+1]].c_str());
    }
    printf("</tr>\n");
  }
  printf("</table></td></tr><tr><td></td><td>\n");
  printf("<table border=1 width=42 height=42 bordercolor=#000000 cellpadding=0 cellspacing=0>\n");
  for (int i = 1; i <= N; i++) {
    printf("<tr>");
    for (int j = 1; j <= N; j++) {
      printf("<td bgcolor=#%s><table><tr><td></td></tr></table></td>", col[c.cube[j][0][i]].c_str());
    }
    printf("</tr>\n");
  }
  printf("</table></td><td colspan=2></td></tr></table>\n");
}

// generate the html solution
void sendHTML()
{
  int m = 0, col, row, maxcol;
  string mov, txt, img;
  //if (disp_graphics == 0) maxcol = 3; else maxcol = 5;
  maxcol = 4;
  if (disp_diagrams)
  {
    printf("<script language=JavaScript>\n");
    printf("// non-script <!--\n");
    printf("// Mcube JavaScript by Eric\n");
    printf("var mov = new Array( ");
    for (int i = 0; i <= thecube.MOV; i++) {
      printf("%i ", thecube.mov[i]);
      if (i < thecube.MOV)
        printf(", ");
    }
    printf(");\n");
    printf(
"\
OnStart()\n\
function ElementGet(xx) {\n\
  return document.getElementById(xx);\n\
}\n\
function OnStart() {\n\
  //ShowAll('true');\n\
}\n\
function ShowStep(name) {\n\
  var step = ElementGet(name);\n\
  if (step.style.display == '')\n\
    step.style.display = 'none';\n\
  else\n\
    step.style.display = '';\n\
}\n\
function ShowGroup(group, see) {\n\
  var step, vis, first = 1, last, i;\n\
  if (see == 'true')\n\
    vis = '';\n\
  else\n\
    vis = 'none';\n\
  for (i = 1; i <= group - 1; i++)\n\
    first = first + mov[i];\n\
  last = first + mov[group] - 1;\n\
  for (i = first; i <= last; i++) {\n\
    step = ElementGet('step' + i);\n\
    step.style.display = vis;\n\
  }\n\
}\n\
function ShowAll(see) {\n\
  var step, vis, i;\n\
  if (see == 'true')\n\
    vis = '';\n\
  else\n\
    vis = 'none';\n\
  for (i = 1; i <= mov[0]; i++) {\n\
    step = ElementGet('step' + i);\n\
    step.style.display = vis;\n\
  }\n\
}\n\
"
    );
    printf("// -->\n");
    printf("</script>\n");
  }
  printf("<noscript>\n");
  printf("<b>your browser has javascript disabled</b><br>\n");
  printf("</noscript>\n");
  printf("<table border=0><tr><td>\n");
  printf("starting position:<br>\n");
  renderHTML(thecube);
  printf("</td></tr></table>\n");
  printf("<br>\n");
  printf("<a href=%smcubeiscool.html target=_blank>about the solver</a> -\n", html.c_str());
  printf("<a href=%s?!cube-%s%s target=_blank>input screen</a><br>\n", inpt.c_str(), parm.c_str(), parm2.c_str());
  printf("<br>\n");
  if (disp_diagrams) {
    printf("<a href=javascript:ShowAll('true')>expand all</a>,\n");
    printf("<a href=javascript:ShowAll('false')>collapse all</a><br>\n");
  }
  if (!disp_graphics && !disp_diagrams) printf("<u>text-only, no diagrams (fastest load)</u> -\n");
  else printf("<a href=%s?cube-%s%s>text-only, no diagrams (fastest load)</a> -\n", exec.c_str(), parm.c_str(), parmcol.c_str());
  if (disp_graphics && !disp_diagrams) printf("<u>graphical, no diagrams (recommended)</u> -\n");
  else printf("<a href=%s?cube-%s%s!withgraphics>graphical, no diagrams (recommended)</a> -\n", exec.c_str(), parm.c_str(), parmcol.c_str());
  if (!disp_graphics && disp_diagrams) printf("<u>text-only, with diagrams (slow load)</u> -\n");
  else printf("<a href=%s?cube-%s%s!withdiagrams>text-only, with diagrams (slow load)</a> -\n", exec.c_str(), parm.c_str(), parmcol.c_str());
  if (disp_graphics && disp_diagrams) printf("<u>graphical, with diagrams (slow load)</u>\n");
  else printf("<a href=%s?cube-%s%s!withgraphics!withdiagrams>graphical, with diagrams (slow load)</a>\n", exec.c_str(), parm.c_str(), parmcol.c_str());
  printf("<br>\n");
  //printf("<b>THIS PROGRAM IS INCOMPLETE</b> but it will be finished in the near future. -- Eric<br>\n"); // remark upon completion
  printf("<b>complete solution: %i moves</b><br>\n", thecube.mov[0]);
  printf("categorized breakdown -<br>\n");
  if (thecube.warnval)
    printf("<b>debug warning: %i</b> (you may ignore this it is just for tracing inefficiencies<br>\n", thecube.warnval);
  printf("<br>\n");
  for (int i = 1; i <= thecube.MOV; i++)
  {
    printf("<b>");
    switch (i)
    {
      case 1:  printf("first-layer centers"); break;
      case 2:  printf("fourth-layer centers"); break;
      case 3:  printf("first-layer corners"); break;
      case 4:  printf("fourth-layer corners position"); break;
      case 5:  printf("fourth-layer corners orient"); break;
      case 6:  printf("3/4 of first-layer edge pairs"); break;
      case 7:  printf("fourth-layer edges"); break;
      case 8:  printf("keyhole first-layer edge pair"); break;
      case 9:  printf("second-layer edges"); break;
      case 10: printf("third-layer edges"); break;
      case 11: printf("side centers"); break;
    }
    printf(": %i moves</b>", thecube.mov[i]);
    if (disp_diagrams) {
      printf("\n");
      printf("<small><a href=javascript:ShowGroup(%i,'true')>expand group</a>,\n", i);
      printf("<a href=javascript:ShowGroup(%i,'false')>collapse group</a></small><br>\n", i);
    }
    else {
      printf("<br>\n");
    }
    printf("<table><tr>\n");
    col = 0;
    row = 0;
    for (int j = 1; j <= thecube.mov[i]; j++) {
      m++;
      col++;
      if (col > maxcol) {
        col = 1;
        row = !row;
        if (row)
          printf("</tr><tr bgcolor=#D0D0D0>");
        else
          printf("</tr><tr>");
      }
      printf("<td valign=top nowrap>\n");
      mov = thesolution.substr(m * 3 - 3, 3);
      if      (mov == "UL.") { thecube.UL(); img = "UL";  txt = "top left"; }
      else if (mov == "uL.") { thecube.uL(); img = "uLi"; txt = "inner top left"; }
      else if (mov == "dL.") { thecube.dL(); img = "dLi"; txt = "inner bottom left"; }
      else if (mov == "DL.") { thecube.DL(); img = "DL";  txt = "bottom left"; }
      else if (mov == "UR.") { thecube.UR(); img = "UR";  txt = "top right"; }
      else if (mov == "uR.") { thecube.uR(); img = "uRi"; txt = "inner top right"; }
      else if (mov == "dR.") { thecube.dR(); img = "dRi"; txt = "inner bottom right"; }
      else if (mov == "DR.") { thecube.DR(); img = "DR";  txt = "bottom right"; }
      else if (mov == "LU.") { thecube.LU(); img = "LU";  txt = "left up"; }
      else if (mov == "lU.") { thecube.lU(); img = "lUi"; txt = "inner left up"; }
      else if (mov == "rU.") { thecube.rU(); img = "rUi"; txt = "inner right up"; }
      else if (mov == "RU.") { thecube.RU(); img = "RU";  txt = "right up"; }
      else if (mov == "LD.") { thecube.LD(); img = "LD";  txt = "left down"; }
      else if (mov == "lD.") { thecube.lD(); img = "lDi"; txt = "inner left down"; }
      else if (mov == "rD.") { thecube.rD(); img = "rDi"; txt = "inner right down"; }
      else if (mov == "RD.") { thecube.RD(); img = "RD";  txt = "right down"; }
      else if (mov == "FC.") { thecube.FC(); img = "FC";  txt = "front clockwise"; }
      else if (mov == "fC.") { thecube.fC(); img = "fCi"; txt = "inner front clockwise"; }
      else if (mov == "bC.") { thecube.bC(); img = "bCi"; txt = "inner back clockwise"; }
      else if (mov == "BC.") { thecube.BC(); img = "BC";  txt = "back clockwise"; }
      else if (mov == "FA.") { thecube.FA(); img = "FA";  txt = "front anticlockwise"; }
      else if (mov == "fA.") { thecube.fA(); img = "fAi"; txt = "inner front anticlockwise"; }
      else if (mov == "bA.") { thecube.bA(); img = "bAi"; txt = "inner back anticlockwise"; }
      else if (mov == "BA.") { thecube.BA(); img = "BA";  txt = "back anticlockwise"; }
      else if (mov == "U2.") { thecube.U2(); img = "U2";  txt = "top half-turn"; }
      else if (mov == "u2.") { thecube.u2(); img = "u2i"; txt = "inner top half-turn"; }
      else if (mov == "d2.") { thecube.d2(); img = "d2i"; txt = "inner bottom half-turn"; }
      else if (mov == "D2.") { thecube.D2(); img = "D2";  txt = "bottom half-turn"; }
      else if (mov == "L2.") { thecube.L2(); img = "L2";  txt = "left half-turn"; }
      else if (mov == "l2.") { thecube.l2(); img = "l2i"; txt = "inner left half-turn"; }
      else if (mov == "r2.") { thecube.r2(); img = "r2i"; txt = "inner right half-turn"; }
      else if (mov == "R2.") { thecube.R2(); img = "R2";  txt = "right half-turn"; }
      else if (mov == "F2.") { thecube.F2(); img = "F2";  txt = "front half-turn"; }
      else if (mov == "f2.") { thecube.f2(); img = "f2i"; txt = "inner front half-turn"; }
      else if (mov == "b2.") { thecube.b2(); img = "b2i"; txt = "inner back half-turn"; }
      else if (mov == "B2.") { thecube.B2(); img = "B2";  txt = "back half-turn"; }
      else if (mov == "CL.") { thecube.CL(); img = "CL";  txt = "whole cube left"; }
      else if (mov == "CR.") { thecube.CR(); img = "CR";  txt = "whole cube right"; }
      else if (mov == "CU.") { thecube.CU(); img = "CU";  txt = "whole cube up"; }
      else if (mov == "CD.") { thecube.CD(); img = "CD";  txt = "whole cube down"; }
      else if (mov == "CC.") { thecube.CC(); img = "CC";  txt = "whole cube clockwise"; }
      else if (mov == "CA.") { thecube.CA(); img = "CA";  txt = "whole cube anticlockwise"; }
      if      (!disp_graphics && !disp_diagrams) {
        printf("%i. %s,\n", m, txt.c_str());
      }
      else if (disp_graphics && !disp_diagrams) {
        printf("%i. <img src=%s%s.gif>\n", m, html.c_str(), img.c_str());
      }
      else if (!disp_graphics && disp_diagrams) {
        printf("<a href=javascript:ShowStep('step%i')>%i. %s</a>,\n", m, m, txt.c_str());
        printf("<div id=step%i style=\"display: none;\">\n", m);
        renderHTML(thecube);
        printf("</div>\n");
      }
      else if (disp_graphics && disp_diagrams) {
        printf("<a href=javascript:ShowStep('step%i')>%i. <img src=%s%s.gif border=0></a>\n", m, m, html.c_str(), img.c_str());
        printf("<div id=step%i style=\"display: none;\">\n", m);
        renderHTML(thecube);
        printf("</div>\n");
      }
      printf("</td>");
    }
    if (col > 0) {
      for (int j = col + 1; j <= maxcol; j++) {
        printf("<td>\n");
        printf("</td>");
      }
    }
    printf("</tr></table><br>\n");
  }
  if (disp_diagrams) {
    printf("<a href=javascript:ShowAll('true')>expand all</a>,\n");
    printf("<a href=javascript:ShowAll('false')>collapse all</a><br>\n");
  }
  if (!disp_graphics && !disp_diagrams) printf("<u>text-only, no diagrams (fastest load)</u> -\n");
  else printf("<a href=%s?cube-%s%s>text-only, no diagrams (fastest load)</a> -\n", exec.c_str(), parm.c_str(), parmcol.c_str());
  if (disp_graphics && !disp_diagrams) printf("<u>graphical, no diagrams (recommended)</u> -\n");
  else printf("<a href=%s?cube-%s%s!withgraphics>graphical, no diagrams (recommended)</a> -\n", exec.c_str(), parm.c_str(), parmcol.c_str());
  if (!disp_graphics && disp_diagrams) printf("<u>text-only, with diagrams (slow load)</u> -\n");
  else printf("<a href=%s?cube-%s%s!withdiagrams>text-only, with diagrams (slow load)</a> -\n", exec.c_str(), parm.c_str(), parmcol.c_str());
  if (disp_graphics && disp_diagrams) printf("<u>graphical, with diagrams (slow load)</u>\n");
  else printf("<a href=%s?cube-%s%s!withgraphics!withdiagrams>graphical, with diagrams (slow load)</a>\n", exec.c_str(), parm.c_str(), parmcol.c_str());
  printf("<br>\n");
  printf("<table border=0><tr><td>\n");
  printf("ending position:<br>\n");
  renderHTML(thecube);
  printf("</td></tr></table>\n");
  printf("<br>\n");
  printf("<a href=%smcubeiscool.html target=_blank>about the solver</a> -\n", html.c_str());
  printf("<a href=%s?!cube-%s%s target=_blank>input screen</a><br>\n", inpt.c_str(), parm.c_str(), parm2.c_str());
  printf("Sorry for the various inefficiencies!<br>\n");
  printf("<a href=%smcubeiscool.html target=_blank>\n", html.c_str());
  printf("If this helped you, please click here.<br>\n");
  printf("<img src=%smcubeiscool.gif border=0></a><br>\n", html.c_str());
  printf("<br>\n");
}

// parse commandline to get the cube
int readcommandline(string cmdln)
{
  string cmd = cmdln;
  col[1] = "FFFFFF"; col[2] = "0000FF"; col[3] = "FF8000";
  col[4] = "00FF00"; col[5] = "FF0000"; col[6] = "FFFF00";
  html = "../../mcube/";
  exec = "mcubecgiout";
  inpt = "mcubecgiin";
  disp_graphics = 0;
  disp_diagrams = 0;
  if (cmd == "") return 1;
  if (cmd.substr(0, 5) != "cube-" || cmd.length() < (N*N*6+5))
    return 1;
  cmd = cmd.substr(5, cmd.length() - 5);
  for (int i = 0; i < (N*N*6); i++)
    if (cmd.at(i) < '1' || cmd.at(i) > '6')
      return 1;
  for (int i = 1; i <= N; i++)
  {
    for (int j = 1; j <= N; j++)
    {
      thecube.cube[j][N+1][N+1-i]     = cmd.at(((i-1)*N+(j-1))      )-'0';
      thecube.cube[0][N+1-i][N+1-j]   = cmd.at(((i-1)*N+(j-1))+N*N  )-'0';
      thecube.cube[j][N+1-i][0]       = cmd.at(((i-1)*N+(j-1))+N*N*2)-'0';
      thecube.cube[N+1][N+1-i][j]     = cmd.at(((i-1)*N+(j-1))+N*N*3)-'0';
      thecube.cube[N+1-j][N+1-i][N+1] = cmd.at(((i-1)*N+(j-1))+N*N*4)-'0';
      thecube.cube[j][0][i]           = cmd.at(((i-1)*N+(j-1))+N*N*5)-'0';
    }
  }
  parm = cmd.substr(0, (N*N*6));
  cmd = cmd.substr((N*N*6), cmd.length() - (N*N*6));
  parm2 = cmd;
  // now to get optional parameters
  while (cmd.length() > 0)
  {
    if (cmd.substr(0, 8) == "!colors-" && cmd.length() >= 44)
    {
      cmd = cmd.substr(8, cmd.length() - 8);
      int n = 1;
      string clr[7];
      for (int i = 1; i <= 6; i++)
      {
        clr[i] = "";
        for (int j = 0; j <= 5; j++)
        {
          if
          ((cmd.at(j) < '0' || cmd.at(j) > '9') &&
           (cmd.at(j) < 'A' || cmd.at(j) > 'F') &&
           (cmd.at(j) < 'a' || cmd.at(j) > 'f'))
            n = 0;
          else clr[i] += cmd.at(j);
        }
        cmd = cmd.substr(6, cmd.length() - 6);
      }
      if (n)
      {
        parmcol = "!colors-";
        for (int i = 1; i <= 6; i++)
        {
          col[i] = clr[i];
          parmcol += col[i];
        }
        parm2 += "!adv";
      }
    }
    else if (cmd.substr(0, 13) == "!withgraphics")
    {
      disp_graphics = 1;
      cmd = cmd.substr(13, cmd.length() - 13);
    }
    else if (cmd.substr(0, 13) == "!withdiagrams")
    {
      disp_diagrams = 1;
      cmd = cmd.substr(13, cmd.length() - 13);
    }
    else
    {
      cmd = "";
    }
  }
  char buf[128], *ini = "mcube.ini";
  string s;
  FILE *fp = fopen(ini, "r");
  if (fp)
  {
    while (fgets(buf, sizeof(buf)-1, fp))
    {
      s = buf;
      if (s.substr(0, 9) == "sitepath=")
      {
        html = "";
        for (int i = 9; i <= s.length() - 1; i++) {
          if (s.at(i)-32 >= 0)
            html += s.at(i);
          else break;
        }
      }
      /*
      else if (s.substr(0, 9) == "execname=")
      {
        exec = "";
        for (int i = 9; i <= s.length() - 1; i++) {
          if (s.at(i)-32 >= 0)
            exec += s.at(i);
          else break;
        }
      }
      */
    }
    fclose(fp);
  }
  return 0;
}

// translate an error code into a readable message
void reporterror(int e)
{
  if      (e == mcube::ERR_NOTINITED)
    printf("mysterious not-inited error - something is fishy.\n");
  else if (e == mcube::ERR_MISPAINTED)
    printf("cubelet error - incorrect cubelets - cube mispainted.\n");
  else if (e == mcube::ERR_NONDESCRIPT)
    printf("nondescript error from findsolution() - cube misassembled.\n");
  else if (e == mcube::ERR_PARITY_EDGE_FLIP)
    printf("parity error - edge flip - cube misassembled.\n");
  else if (e == mcube::ERR_PARITY_CORNER_ROTATION)
    printf("parity error - corner rotation - cube misassembled.\n");
  else if (e == mcube::ERR_PARITY_CORNER_BACKWARD)
    printf("parity error - backward corner - cube mispainted.\n");
  else if (e == mcube::ERR_PARITY_CENTER_SWAP)
    printf("parity error - center swap - cube misassembled.\n");
  else
    printf("unexpected error - solvecube() returned %i.\n", e);
}

// main entry point
int main(int argc, char* argv[])
{
  string cmdln = "";
  if (argc >= 2)
    cmdln = argv[1];
  printf("Content-Type: text/html\n\n");
  printf("<html>\n");
  printf("<!-- Generated by Mcube - 4x4x4 Rubik's Cube Solver -->\n");
  printf("<head>\n");
  printf("<title>4x4x4 Rubik's Cube Solution</title>\n");
  printf("<meta name=Generator content=Mcube_by_Eric_Dietz>\n");
  printf("</head>\n");
  printf("<body bgcolor=#FFFFFF text=#000040 link=#000080 vlink=#800080>\n");
  printf("<font face=Arial>\n");
  printf("<table width=90%% border=0 align=center><tr><td>\n");
  printf("<font size=3><p align=left>\n");
  printf("4x4x4 Rubik's Cube Solver by <a href=mailto:root@wrongway.org>Eric Dietz</a> (c) 2005<br>\n");
  printf("Version %s (%s)<br>\n", version, mcube::version);
  printf("<br>\n");
  if (readcommandline(cmdln))
  {
    printf("ERROR: non-protocol input entered.\n");
    printf("Try using the Mcube solve.html to input cubes,\n");
    printf("or read documentation for command-line parameter.\n");
    printf("<br>\n");
    printf("Client sent:<br>\n");
    printf("%s\n", cmdln.c_str());
    printf("<br>\n");
  }
  else
  {
    int out;
    out = thecube.solvecube();
    if (out)
    {
      printf("Error found in starting position:\n");
      reporterror(out);
      printf("<br>\n");
      printf("your entry:<br>\n");
      printf("<table border=0><tr><td>\n");
      printf("starting position:<br>\n");
      renderHTML(thecube);
      printf("</td></tr></table>\n");
      printf("<br>\n");
      printf("<a href=%s?!cube-%s%s target=_blank>input screen</a><br>\n", inpt.c_str(), parm.c_str(), parm2.c_str());
    }
    else
    {
      thesolution = thecube.solution;
      sendHTML();
    }
  }
  printf("</td></tr></table>\n");
  printf("</body>\n");
  printf("</html>\n");
  return 0;
}

//
